package it.mokabyte.pattern.valueobject;

import java.util.*;

/**
 * <P>This is the Object Model of mail
 */
public class MailOM implements java.io.Serializable{

  private String recipient;
  private String bodyMail;
  private String subject;
  private String hostMailServer;
  private String from;

  private static final String RECIPIENT = "srossini@mokabyte.it";
  private static final String MESSAGE_TEXT = "Thank you for your order !";

  public MailOM() {
    this(RECIPIENT,MESSAGE_TEXT, null, null, null);
  }

  public MailOM(String rec,String msg) {
    this(rec, msg , null, null, null);
  }

  public MailOM(String rec,String msg, String sub) {
    this(rec, msg, sub, null, null);
  }

  public MailOM(String rec, String msg, String sub, String hms) {
    this(rec, msg, sub, hms, null);
  }

  public MailOM(String rec, String msg, String sub, String hms, String from) {
    this.recipient = rec;
    this.bodyMail = msg;
    this.subject = sub;
    this.hostMailServer = hms;
    this.from = from;
  }

  // Accessors
  public String getRecipient(){
      return this.recipient;
  }

  public String getBodyMail(){
      return this.bodyMail;
  }

  public String getSubject(){
      return this.subject;
  }

  public String getHostMailServer(){
      return this.hostMailServer;
  }

  public String getFrom(){
      return this.from;
  }

  public boolean equals(Object obj){
      if( ((MailOM)obj).getRecipient().equals(this.recipient) )
        return true;
      else
        return false;
  }

  public String toString(){
      return "MailOM: " + this.recipient + "-" + this.bodyMail + "-" + this.subject + "-" + this.hostMailServer + "-" + this.from;
  }
}
