package it.mokabyte.pattern.client;

import javax.naming.*;
import java.util.Properties;
import javax.rmi.PortableRemoteObject;

import it.mokabyte.pattern.ejb.session.stateless.FacadeHome;
import it.mokabyte.pattern.ejb.session.stateless.Facade;
import it.mokabyte.pattern.valueobject.MailOM;

import it.mokabyte.pattern.locator.MyServiceLocator;
import it.mokabyte.pattern.util.JndiConfig;

import it.mokabyte.pattern.util.Chronus;
/**
 * <p>Title: NoMessageFacadeTestClient</p>
 * <p>Description: client dell'EJB Facade Session Stateless</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author S.Rossini
 * @version 1.0
 */
public class NoMessageFacadeTestClient {

  /**Costruttore */
  public NoMessageFacadeTestClient() {
    try {
      Context ctx = new InitialContext();
      Object result = ctx.lookup("MokaFacadeSL");
      FacadeHome facadeHome = (FacadeHome)PortableRemoteObject.narrow(result, FacadeHome.class);
      Facade facade = facadeHome.create();
      Chronus krono = new Chronus();
      System.out.println(new java.util.Date().toString()+": prima dell'invio del messaggio...");
      krono.begin();
      facade.sendNotice(new MailOM("srossini@mokabyte.it","CIAO!!!"));
      krono.end();
      System.out.println(new java.util.Date().toString()+": messaggio inviato!");
      System.out.println("Tempo trascorso(H:m:s):" + Chronus.convertInTime(krono.getElapsed()));
    }
    catch(Exception e) {
      System.out.println(" # EXCEPTION:" + e.getMessage());
      e.printStackTrace();
    }
  }

  private Context getInitialContext() throws Exception {
    String url = "t3://localhost:7001";
    String user = null;
    String password = null;
    Properties properties = null;
    try {
      properties = new Properties();
      properties.put(Context.INITIAL_CONTEXT_FACTORY, "weblogic.jndi.WLInitialContextFactory");
      properties.put(Context.PROVIDER_URL, url);
      if (user != null) {
        properties.put(Context.SECURITY_PRINCIPAL, user);
        properties.put(Context.SECURITY_CREDENTIALS, password == null ? "" : password);
      }
      return new InitialContext(properties);
    }
    catch(Exception e) {
      System.out.println("Unable to connect to WebLogic server at " + url);
      System.out.println("Please make sure that the server is running.");
      throw e;
    }
  }

  /**Main method*/
  public static void main(String[] args) {
      new NoMessageFacadeTestClient();
  }
}